#!/usr/bin/env python
# Spoustet jako: python zemepis.py

from numpy import *

# radian
r = 180/pi

# namerene zenitove vzdalenosti
z1 = 50
z2 = 70

# souradnice a hvezdny cas, stupne
a1 = 15*(4+36/60) # [deg]
d1 = 16+30/60     # [deg]
h1 = 20           # [hodiny]
H1 = 15*h1 - a1   # hodinovy uhel

# souradnice a hvezdny cas, stupne
a2 = 15*(5+17/60)
d2 = 46
h2 = 23
H2 = 15*h2 - a2

# priblizny (pocatecni) odhad zemepisne polohy
l = 15
f = 50

print("RESENI:")
print("Iterace    zemepisna delka   zemepisna sirka")

for i in 1,2,3,4,5:

  # pomocne veliciny
  q1 = sin(d1/r)*sin(f/r)+cos(d1/r)*cos(f/r)*cos((l+H1)/r)
  q2 = sin(d2/r)*sin(f/r)+cos(d2/r)*cos(f/r)*cos((l+H2)/r)

  # prave strany, rozdil mezi merenou a 
  # vypoctenou zenitovou vzdalenosti ve stupnich
  p = array([r*arccos(q1) - z1, r*arccos(q2) - z2])
   
  # substituce
  u = -1/sqrt(1 - q1**2)
  v = -1/sqrt(1 - q2**2)

  # matice derivaci
  m11 = -u*sin((H1+l)/r)*cos(d1/r)*cos(f/r)
  m12 = u*(sin(d1/r)*cos(f/r) - cos(d1/r)*sin(f/r)*cos((H1+l)/r))
  m21 = -v*sin((H2+l)/r)*cos(d2/r)*cos(f/r)
  m22 = v*(sin(d2/r)*cos(f/r) - cos(d2/r)*sin(f/r)*cos((H2+l)/r))
  m = array([[ m11, m12 ], [m21, m22 ]])

  # vypocet linearnich rovnic
  x = linalg.solve(m,p)
 
  # pricteni rozdilu k pocatecnimu odhadu
  l = l - x[0]
  f = f - x[1]

  print(i,l,f)

# fin
